org.eclipse.jgit.diff

## Class SequenceComparator<S extends Sequence>

- java.lang.Object
- - org.eclipse.jgit.diff.SequenceComparator<S>

Type Parameters:
  `S` - type of sequence the comparator supports.

Direct Known Subclasses:
  HashedSequenceComparator, RawTextComparator, SubsequenceComparator

    public abstract class SequenceComparator<S extends Sequence>
    extends Object

Equivalence function for a `Sequence` compared by difference algorithm.

Difference algorithms can use a comparator to compare portions of two sequences and discover the minimal edits required to transform from one sequence to the other sequence.

Indexes within a sequence are zero-based.

### Constructor Summary

Constructors
Constructor and Description
`SequenceComparator()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract boolean` `equals(S a, int ai, S b, int bi)` Compare two items to determine if they are equivalent.
`abstract int` `hash(S seq, int ptr)` Get a hash value for an item in a sequence.
`Edit` `reduceCommonStartEnd(S a, S b, Edit e)` Modify the edit to remove common leading and trailing items.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SequenceComparator

    public SequenceComparator()

### Method Detail

#### equals

    public abstract boolean equals(S a,
                                   int ai,
                                   S b,
                                   int bi)

Compare two items to determine if they are equivalent. It is permissible to compare sequence `a` with itself (by passing `a` again in position `b`).

Parameters:
  `a` - the first sequence.
  `ai` - item of `ai` to compare.
  `b` - the second sequence.
  `bi` - item of `bi` to compare.
Returns:
  true if the two items are identical according to this function's equivalence rule.

#### hash

    public abstract int hash(S seq,
                             int ptr)

Get a hash value for an item in a sequence. If two items are equal according to this comparator's `equals(Sequence, int, Sequence, int)` method, then this hash method must produce the same integer result for both items. It is not required for two items to have different hash values if they are are unequal according to the `equals()` method.

Parameters:
  `seq` - the sequence.
  `ptr` - the item to obtain the hash for.
Returns:
  hash the hash value.

#### reduceCommonStartEnd

    public Edit reduceCommonStartEnd(S a,
                                     S b,
                                     Edit e)

Modify the edit to remove common leading and trailing items. The supplied edit `e` is reduced in size by moving the beginning A and B points so the edit does not cover any items that are in common between the two sequences. The ending A and B points are also shifted to remove common items from the end of the region.

Parameters:
  `a` - the first sequence.
  `b` - the second sequence.
  `e` - the edit to start with and update.
Returns:
  `e` if it was updated in-place, otherwise a new edit containing the reduced region.